Subject: Optimize scm cartesian product (or avoid it)

Description: McScM is only able to model-check _flat_ models, i.e., models containing a single global automaton.  To this 

end, the tool first computes the cartesian product of the local automata.  This operation is crucial, and should 

be optimized.



_Suggestions_:

* do not use string identifiers (of the form sender_0xreceiver_1x...), as they use a *lot of memory*.

* perform the cartesian product in the Scm wrapper module.

* compute the cartesian product on-the-fly (selectable by option)



However, for realistic scm models with several machines, the cartesian product will simply be too large (for 

an explicit representation).  In the future, McScM should avoid the cartesian product completely.  To this end, 

the input to the model-checker functors will have to expose the local machines composing the model.

History

07/22/2010 03:54 pm - Grégoire Sutre

- File petgen.4.scm added

The attached file resembles the _peterson_3.scm_ example, but with four processes.  It was obtained by the following command :



<pre>

python examples/other/peterson_generator.py 4 > petgen.4.scm

</pre>



On this _petgen.4.scm_ example, the computation of the cartesian product requires more that 2 GiB of RAM (on a 64-bit workstation) :



<pre>

./bin/mcscm.native -verbose ./petgen.4.scm

MCSCM - Model Checker for Systems of Communicating Machines

Parsing input SCM description... done.

Computing global SCM by cartesian product of local systems...^C

</pre>

04/08/2011 01:42 pm - Grégoire Sutre

- Assignee set to Grégoire Sutre

- Target version set to 1.x

- Start date deleted (07/22/2010)

06/23/2011 12:33 pm - Tristan Le Gall

- Assignee changed from Grégoire Sutre to Tristan Le Gall

08/23/2011 06:20 pm - Grégoire Sutre

- Target version changed from 1.x to 1.3

Files

petgen.4.scm 13.3 kB 07/22/2010 Grégoire Sutre
